#!/bin/sh 

# Signal handler.
SignalTrap()
{
	echo "Received signal.  Update aborting."
	exit 1
}

# Pop the error and exit the script
function popuptext
{    
	/tmp/utserviceutility popup $POPUP_TXT_FILE	
	echo "End of script ${SCRIPT} $(date)"
	sync
	sync
	sleep 2
	exit 1
}

# Function unmount Map data
function UnmountMapData
{
	# Unmount
	umount -f /fs/sd/MAP/
	if [ $? -ne 0 ]; then
		echo "UnMount of /fs/sd/MAP failed - $?" >> $LOG_PATH
		echo "UnMount of /fs/sd/MAP failed - $?" > $POPUP_TXT_FILE
		popuptext
	fi
	sleep 1

}

# Function Delete MapChunk data
function DeleteMapChunkData
{
	echo "slay NAV_Manager" >> $LOG_FILE
	slay NAV_Manager

	# Unmount all the maps 
	for map_images in /fs/images/map*.img
	do
		UnmountMapData
		echo "Umouning of "$map_images" is completed" >> $LOG_FILE
	done

	# Delete all the map.imag files
	echo "Deleting "$map_images" ..."
	rm -f /fs/images/map*.img
	if [ $? -ne 0 ]; then
		echo "Failed Deleting map database " >> $LOG_FILE
		echo "Failed Deleting map database. " > $POPUP_TXT_FILE
		popuptext
	else
		echo "Success in Deleting map database .." >> $LOG_FILE
		sync
		sync
		sleep 1
	fi
	sleep 2

	# Delete the respective .inf file
	rm -f /fs/rwdata/.Version/*-14G421-*.inf
	if [ $? -ne 0 ]; then
		echo "Error: can't delete INF file corresponding MAP databse " >> $LOG_FILE
		echo "Error: can't delete INF file corresponding MAP databse " > $POPUP_TXT_FILE
		popuptext
	else
		echo "Success: Deleted INF file corresponding MAP databse " >> $LOG_FILE
	fi
	sync
	sync
	sleep 1

	# Delete the respective .cksum file
	rm -f /fs/rwdata/.chksum/map*.cksum
	if [ $? -ne 0 ]; then
		echo "Error: can't delete chksum file corresponding MAP databse " >> $LOG_FILE
		echo "Error: can't delete chksum file corresponding MAP databse " > $POPUP_TXT_FILE
		popuptext
	else
		echo "Success: Deleted chksum file corresponding MAP databse " >> $LOG_FILE
	fi
	sync
	sync
}

# Function unmount Voice data
function UnmountVoiceData
{
	# Unmount
	umount -f /fs/Nuance/
	if [ $? -ne 0 ]; then
		echo "UnMount of /fs/Nuance failed - $?" >> $LOG_PATH
		echo "UnMount of /fs/Nuance failed - $?" > $POPUP_TXT_FILE
		popuptext
	fi
	sleep 1
}

# Function Delete VoiceChunk data
DeleteVoiceChunkData
{
	echo "slay VCA_Manager" >> $LOG_FILE
	slay VCA_Manager

	# Unmount all voice images
	for voice_images in /fs/images/voice*.img
	do
		UnmountVoiceData
		echo "Umouning of "$voice_images" is completed" >> $LOG_FILE
	done

	# Delete only the voice nav files
	echo "Deleting "$voice_images" ..."
	rm -f /fs/images/voice_*.img
	if [ $? -ne 0 ]; then
		echo "Failed Deleting voice database " >> $LOG_FILE
		echo "Failed Deleting voice database " > $POPUP_TXT_FILE
		popuptext
	else
		echo "Success in Deleting voice database .." >> $LOG_FILE
		sync
		sync
		sleep 1
	fi
	sleep 2

	# Delete the respective .inf file
	rm -f /fs/rwdata/.Version/*-14G422-*.inf
	if [ $? -ne 0 ]; then
		echo "Error: can't delete INF file corresponding VOICE databse " >> $LOG_FILE
		echo "Error: can't delete INF file corresponding VOICE databse " > $POPUP_TXT_FILE
		popuptext
	else
		echo "Success: Deleted INF file corresponding VOICE Pdatabse " >> $LOG_FILE
	fi
	sync
	sync
	sleep 1

	# Delete the respective .cksum file
	rm -f /fs/rwdata/.chksum/voice_*.cksum
	if [ $? -ne 0 ]; then
		echo "Error: can't delete chksum file corresponding VOICE databse " >> $LOG_FILE
		echo "Error: can't delete chksum file corresponding VOICE databse " > $POPUP_TXT_FILE
		popuptext
	else
		echo "Success: Deleted chksum file corresponding VOICE databse " >> $LOG_FILE
	fi
	sync
	sync
}

# Set Signal Trap
trap SignalTrap INT QUIT TERM ABRT STOP

# Set the permission for the bin used in this utility
cd /tmp
chmod 777 /tmp/utserviceutility
sync
syncum
sleep 1

# Set the variables
USB_PATH=$1
LOG_FILE=/tmp/chunckdelete_status.txt
RWDATA_PATH=/fs/rwdata
POPUP_TXT_FILE=/tmp/pop_up.txt

# Remove log file
rm -f $RWDATA_PATH/chunckdelete_status.txt
sync
sync
sleep 1

echo " ==== Image chunk delete utility start at $(date) === " >> $LOG_FILE

# Delete Map chunks
DeleteMapChunkData

# Delete Voice Chunks
DeleteVoiceChunkData

# Capture status of the update in the log
echo "Update Successful..." >> $LOG_FILE
echo "Success: Image chunk delete end at $(date) === " >> $LOG_FILE

# Copy the log to module
cp $LOG_FILE $RWDATA_PATH/chunckdelete_status.txt
sync
sync
sleep 2
